# -*- coding: utf-8 -*-
###################################################################################
#
#    Cybrosys Technologies Pvt. Ltd.
#
#    Copyright (C) 2019-TODAY Cybrosys Technologies(<https://www.cybrosys.com>).
#    This program is free software: you can modify
#    it under the terms of the GNU Affero General Public License (AGPL) as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <https://www.gnu.org/licenses/>.
#
###################################################################################

from odoo import models,fields,api,tools


class ProductBrand(models.Model):
    _inherit = 'product.template'

    brand_id = fields.Many2one('product.brand',string='Brand')

class BrandProduct(models.Model):
    _name = 'product.brand'


    name= fields.Char(String="Name")
    brand_image = fields.Binary()
    member_ids = fields.One2many('product.template','brand_id')
    product_count = fields.Char(String='Product Count',compute='get_count_products',store=True)

    @api.depends('member_ids')
    def get_count_products(self):
        self.product_count = len(self.member_ids)

class BrandPivotInvoicing(models.Model):
    _inherit="account.invoice.report"

    brand_id=fields.Many2one ('product.brand' ,string='Brand')


    def _select(self):
        res=super (BrandPivotInvoicing,self)._select ()
        query=res.split ('template.categ_id AS product_categ_id,' ,1)
        res=query [0] + 'template.categ_id as product_categ_id,template.brand_id as brand_id,' + query [1]
        return res

    def _group_by(self):
        res=super (BrandPivotInvoicing,self)._group_by ()
        query=res.split ('template.categ_id,' ,1)
        res=query [0] + 'template.categ_id,template.brand_id,' + query [1]
        return res





